package Logica;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 *
 * @author Felipe J Mendoza
 */
public class Terrenos {

     private int id;
     private double ancho;
     private double largo;
     private double costo;
     private double tamaño;
     private double costoTotal;
     private Connection conexion;


    public Terrenos(int id, double ancho, double largo, double costo, double tamaño, double costoTotal) {
        this.id = id;
        this.ancho = ancho;
        this.largo = largo;
        this.costo = costo;
        this.tamaño = tamaño;
        this.costoTotal = costoTotal;
    }

    public Terrenos() {
        this.setId(0);
        this.setAncho(0);
        this.setLargo(0); 
        this.setCosto(0); 
        this.setTamaño(0); 
        this.setCostoTotal(costoTotal); 
    }
     


    public void setId(int id) {
        this.id = id;
    }

    public void setAncho(double ancho) {
        this.ancho = ancho;
    }

    public void setLargo(double largo) {
        this.largo = largo;
    }

    public void setCosto(double costo) {
        this.costo = costo;
    }

    public void setTamaño(double tamaño) {
        this.tamaño = tamaño;
    }

    public void setCostoTotal(double costoTotal) {
        this.costoTotal = costoTotal;
    }

    public int getCodigo() {
        return id;
    }

    public double getAncho() {
        return ancho;
    }

    public double getLargo() {
        return largo;
    }

    public double getCosto() {
        return costo;
    }

    public double getTamaño() {
        return tamaño;
    }

    public double getCostoTotal() {
        return costoTotal;
    }

    
    public double calcularTam(){
       
        tamaño= this.largo*this.ancho;
        return tamaño;
    }
    public double calcularCostoTotal(){
        costoTotal=this.calcularTam()* this.costo;
        return costoTotal;
    }
    public Connection conectar(){
            try {
            //Driver JDBC
            Class.forName("com.mysql.jdbc.Driver");
            //Nombre del servidor. localhost:3306 es la ruta y el puerto de la conexión MySQL
            //terreno es el nombre que le dimos a la base de datos
            String servidor = "jdbc:mysql://localhost:3306/terreno";
            //El root es el nombre de usuario por default. No hay contraseña
            String usuario = "root";
            String pass = "";
            //Se inicia la conexión
            conexion = DriverManager.getConnection(servidor, usuario, pass);
 
        } catch (ClassNotFoundException ex) {
            JOptionPane.showMessageDialog(null, ex, "Error en la conexión a la base de datos: " 
                    + ex.getMessage(), JOptionPane.ERROR_MESSAGE);
            conexion = null;
        } catch (SQLException ex) {
            JOptionPane.showMessageDialog(null, ex, "Error en la conexión a la base de datos: " 
                    + ex.getMessage(), JOptionPane.ERROR_MESSAGE);
            conexion = null;
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, ex, "Error en la conexión a la base de datos: " 
                    + ex.getMessage(), JOptionPane.ERROR_MESSAGE);
            conexion = null;
        } finally {
            JOptionPane.showMessageDialog(null, "Conexión Exitosa");
            return conexion;
        }
     }
    public void registrarTerreno(){
         
             PreparedStatement comando;
             conectar();
            try { 
                //pasar sentencia a mysql
                comando = conexion.prepareStatement("insert into terrenos values (?,?,?,?,?,?)");
               //pasar los valores a los campos segun el orden comando.setInt
                comando.setInt(1, id);
                comando.setDouble(2, ancho);
                comando.setDouble(3, largo);
                comando.setDouble(4, costo);
                comando.setDouble(5, tamaño);
                comando.setDouble(6, costoTotal);
                //Ejecutar Sentencia
                int resp = comando.executeUpdate();
                JOptionPane.showMessageDialog(null, resp+ "Fila(s) afecta(s)");
            } catch (SQLException ex) {
          JOptionPane.showMessageDialog(null, "Error al registrar");
         }
    }
    public void consultarTerreno(){
        PreparedStatement comando;
             conectar();
             ResultSet resultado;
             conectar();
       
            try {
                comando = conexion.prepareStatement("Select * from terrenos where id=  ?");
                comando.setInt(1, id);
                resultado = comando.executeQuery();
                if(resultado.first()){
                    id=(int) resultado.getDouble("id");
                    ancho=resultado.getDouble("ancho");
                    largo=resultado.getDouble("largo");
                    costo=resultado.getDouble("costo");
                    tamaño=resultado.getDouble("tamaño");
                    costoTotal=resultado.getDouble("costoTotal");
                }
            } catch (SQLException ex) {
                Logger.getLogger(Terrenos.class.getName()).log(Level.SEVERE, null, ex);
            }
        
        
    }
    public void modificarTerreno(){
       PreparedStatement comando;
             conectar();
            try { 
                //pasar sentencia a mysql
                comando = conexion.prepareStatement("UPDATE  terrenos set ancho=?, "
                        + "largo=?, costo=?, tamaño=?, costoTotal=? WHERE codigo= ?");
        
               //pasar los valores a los campos segun el orden comando.setInt
                comando.setDouble(1, ancho);
                comando.setDouble(2, largo);
                comando.setDouble(3, costo);
                comando.setDouble(4, tamaño);
                comando.setDouble(5, costoTotal);
                comando.setDouble(6, id);
                
                //Ejecutar Sentencia
                int resp = comando.executeUpdate();
                JOptionPane.showMessageDialog(null, resp+ "Fila(s) afecta(s)");
            } catch (SQLException ex) {
          JOptionPane.showMessageDialog(null, "Error al registrar");
         }  
    }
    
        public void eliminiarTerreno(int id) throws SQLException{
        PreparedStatement comando;
        conectar();
        try {
            comando = conexion.prepareStatement("DELETE from Terreno where id=?");
            comando.setInt(1, id);
            int res= comando.executeUpdate();
            JOptionPane.showMessageDialog(null, res + "Fila(s) aefectada(s)");
        } catch (SQLException ex) {
            JOptionPane.showMessageDialog(null, "Error al Eliminar"+ex.getMessage());
        }
    }

    public void eliminiarTerreno(String id) {
        throw new UnsupportedOperationException("Not supported yet."); 
//To change body of generated methods, choose Tools | Templates.
    }
}


    
